/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

/****************************************************************************
 gdbserial.h - serial-specific header file

 MODIFICATION HISTORY
 --------------------
 v1.0,19sep05,Suresh DS   written
 v1.1,26dec05,Suresh DS		cleanup

 DESCRIPTION
 -----------
 This file includes the relevant header files in NETOS and defines the macros 
 needed by gdb stub in serial communication mode. The serial 
 communication happens thro' UART1 in xlr.

****************************************************************************/

#ifndef __GDBSERIAL_H__
#define __GDBSERIAL_H__

/* include files */
#include "pic.h"
#include "uart.h"

#ifndef UART1_REG_BITS
/* UART1 related definitions */
#define UART_IER_RDAI 0x01
#define UART_IER_RLSI 0x04
#define UART_LSR_DRI 0x01
#define UART_LSR_OEI 0x02
#define UART_LSR_PEI 0x03
#define UART_LSR_FEI 0x04
#define UART_LSR_BEI 0x05
#define UART_LSR_TFE 0x06
#define UART_LSR_TEI 0x07
#define UART_LSR_ERR 0x80
#endif

#ifndef GDB_PIC_UART_1_IRQ
#define GDB_PIC_UART_1_IRQ 1
#endif

#endif				// #ifndef __GDBSERIAL_H__
