/***********************************************************************
Copyright 2003-2010 Netlogic Microsystems Inc. (“Netlogic”).
This is a derived work from software originally provided by the external
entity identified below. The licensing terms and warranties specified in
the header of the original work apply to this derived work.

*****************************#NETL_1#********************************/
/*-
 * Copyright (c) 1991, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Berkeley Software Design, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are penlmtted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written penlmssion.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)cdefs.h	8.8 (Berkeley) 1/9/95
 * $FreeBSD: src/sys/sys/cdefs.h,v 1.88.2.2 2006/01/31 17:57:16 stefanf Exp $
 */

#ifndef	_CDEFS_H
#define	_CDEFS_H

#include <sys/cdefs.h>

#define CACHELINE_SIZE 32

#define __dead2     __attribute__((__noreturn__))
#define __pure2     __attribute__((__const__))
#define __unused    __attribute__((__unused__))
#define __used      __attribute__((__used__))
#define __packed    __attribute__((__packed__))
#define __aligned(x)    __attribute__((__aligned__(x)))
#define __section(x)    __attribute__((__section__(x)))

#if 0 
#define __shared_memory__          __attribute__ ((section (".netos.shmem")))
#define __shared_memory_bss__      __attribute__ ((section (".netos.shmem")))
#define __aligned_shared_memory__  __attribute__((__aligned__(32))) __attribute__ ((section (".netos.shmem")))
#else
#define __shared_memory__
#define __shared_memory_bss__
#define __aligned_shared_memory__  __attribute__((__aligned__(32)))
#endif

#define ____cacheline_aligned      __attribute__((__aligned__(CACHELINE_SIZE)))

#define __STR(x) #x
#define STR(x) __STR(x)

#define __STRING(x) #x
#define STRING(x) __STRING(x)

#undef __CONCAT1
#undef __CONCAT

#define __CONCAT1(x,y)   x ## y
#define __CONCAT(x,y)   __CONCAT1(x,y)

/*      MIPS Subprogram Interface Model */
#ifndef _MIPS_SIM_ABIX32
#define _MIPS_SIM_ABIX32	4	/* 64 bit safe, ILP32 o32 model */
#endif
#ifndef _MIPS_SIM_ABI64
#define _MIPS_SIM_ABI64		3
#endif
#ifndef _MIPS_SIM_NABI32
#define _MIPS_SIM_NABI32	2	/* 64bit safe, ILP32 n32 model */
#endif
#ifndef _MIPS_SIM_ABI32
#define _MIPS_SIM_ABI32		1
#endif

#define _MIPS_BSD_API_LP32	_MIPS_SIM_ABI32
#define	_MIPS_BSD_API_LP32_64CLEAN	_MIPS_SIM_ABIX32
#define	_MIPS_BSD_API_N32	_MIPS_SIM_NABI32
#define	_MIPS_BSD_API_LP64	_MIPS_SIM_ABI64

#define likely(x)   __builtin_expect((x),1)
#define unlikely(x) __builtin_expect((x),0)

#define prefetch(hint, addr) __asm__ __volatile__("pref %0, 0(%1)\n"::"i"(hint),"r"(addr))

#endif /* !_CDEFS_H_ */
