/***********************************************************************
Copyright 2003-2010 Netlogic Microsystems (“Netlogic”). All rights
reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.
*****************************#NETL_2#********************************/

#ifndef _L2_CACHE_H
#define _L2_CACHE_H

// ---------------------------------------------------------------------------
// Defines

// --------------------------------------------------
// Test Specific

#define ARRAY_SIZE				8192

// --------------------------------------------------
// General Addresses

#define ADDR_OFF_BANK				5
#define ADDR_OFF_SET				8
#define ADDR_OFF_TAG				15	


// --------------------------------------------------
// L2 Control Register Addresses

#define L2_ADDR_OFF_REG				2
#define L2_ADDR_OFF_BANK			5
#define L2_ADDR_OFF_GROUP			8
#define L2_ADDR_OFF_CONFIG			12

#define L2_ADDR_FLD_REG_L2_FEATURE		0x0
#define L2_ADDR_FLD_REG_L2_CMD			0x1
#define L2_ADDR_FLD_REG_L2_TAG_VLD_ARRAY	0x5
#define L2_ADDR_FLD_CONFIG_L2			0x1b


// --------------------------------------------------
// L2 Feature Control

#define L2_FEATURE_OFF_GDW			24
#define L2_FEATURE_OFF_N			2
#define L2_FEATURE_OFF_O			1
#define L2_FEATURE_OFF_P			0


// --------------------------------------------------
// L2 CMD Register

#define L2_CMD_OFF_SET				22
#define L2_CMD_OFF_WAY				19
#define L2_CMD_OFF_VBITS			16

#define L2_CMD_FLD_VBIT_INVALID			0x0
#define L2_CMD_FLD_VBIT_CLEAN_LINE		0x1
#define L2_CMD_FLD_VBIT_DIRTY_LINE		0x2
#define L2_CMD_FLD_VBIT_LOCK_LINE		0x4
#define L2_CMD_FLD_VBIT_LOCK_CLEAN_LINE		0x5
#define L2_CMD_FLD_VBIT_LOCK_DIRTY_LINE		0x6

#define L2_CMD_FLD_CMD_READ_VLD_ARRAY		0x0
#define L2_CMD_FLD_CMD_WRITE_VLD_ARRAY		0x1
#define L2_CMD_FLD_CMD_READ_TAG_RAM		0x2
#define L2_CMD_FLD_CMD_WRITE_TAG_RAM		0x3
#define L2_CMD_FLD_CMD_EVICT_LINE		0x8


// --------------------------------------------------
// L2 Tag/Vld Array Register

#define L2_TAG_OFF_TAG				7

#define NUM_SETS 1024
#define NUM_WAYS 8

extern void flush_l2_cache(void);
#endif
