/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _NAE_H
#define _NAE_H

#include <mempool.h>
#include <reent.h>

typedef struct _nae_port_info {
	int id;
	int num_free_desc;
	mpoolptr_t free_desc_mem;
	int init_done;
} nae_port_t;

extern void* alloc_nae_mem(int num_nae_ports, int start_port);
extern int nae_open(struct _reent *ptr, const char *file,  int flags, int mode);

struct nae_shm_vars {
	spinlock_t init_lock;
	int init_done;
};


/* Some defines for FDT
 */
#define NAE_CFG_NODE            "/soc/nae-cfg"
#define UCORE_CFG_NODE          "/soc/nae-cfg/ucore/src@1"
#define     VAL_UCORE_RESET(x)              (((x) & NAE_UCORE_MASK)<<8) 
#define MAX_SGMII_PORTS 19
#define NAE_IF_FMT "/sysconfig/node0/nae/if%d"
#define NAE_FD_BASE 10
#define NAE_DESC_HDR_SIZE 64
#define XLP_CACHE_LINE_SIZE 64


#endif
