/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#ifndef __NLM_SEM_STRUCT_H
#define __NLM_SEM_STRUCT_H

#define SEM_OPEN    0
#define SEM_CLOSE   1
#define SEM_UNLINK  2

/* To force alignment on 64bit boundary */
#if (_MIPS_SZLONG == 32)
#define ABI_PAD(id) int pad_##id
#else

#define ABI_PAD(id)
#endif

struct sem_open_struct
{
    unsigned long long name;
    int oflag;
    mode_t mode;
    unsigned int value;
    ABI_PAD(0);
    unsigned long long ret; /*return value*/
};

struct sem_close_struct
{
    unsigned long long sem;
    int ret; /*return value*/
    ABI_PAD(0);
};

struct sem_unlink_struct
{
    unsigned long long name;
    int ret; /*return value*/
    ABI_PAD(0);
};

struct semparam
{
    int index;
	ABI_PAD(0);
    union {
        struct sem_open_struct open;
        struct sem_close_struct close;
        struct sem_unlink_struct unlink;
    };
};

#endif
