#ifndef _NETOS_TLB_H_
#define _NETOS_TLB_H_
/* Maximum bits needed to hold physical or virtual addr */
/* Following are configurable params */
#define MAX_VIRT_PHYS_BITS 35
#define MIN_PAGE_BITS  20
/* Above are configurable params */
#define MAX_PAGE_BITS  28
#define MIN_PAGE_SIZE (1 << MIN_PAGE_BITS)
#define PHYS_VIRT_NUM_PTE (1 << (MAX_VIRT_PHYS_BITS - MIN_PAGE_BITS - 1))

#ifdef _ABI64
#define MAX_VIRT_BITS MAX_VIRT_PHYS_BITS
#else /* _ABI64 */
#define MAX_VIRT_BITS 31
#endif /* _ABI64 */
#define NUM_PTE (1 << (MAX_VIRT_BITS - MIN_PAGE_BITS - 1))
#define MAX_VIRT_ADDR ((1ULL << MAX_VIRT_BITS) - 1)

#ifndef __ASSEMBLY__
struct tlb_struct{
	unsigned long long entrylo0;
	unsigned long long entrylo1;
};


#define MAX_TLB_MAPPINGS 16
#endif /* __ASSEMBLY__ */
#endif
