/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _SYSTEM_H
#define _SYSTEM_H

#define XLx_NUM_CPUS 					32
#define CPU_STACK_SIZE 					16384
#define CPU_STACK_INITIAL_FRAME_SIZE 	176
#define MIN_HEAP_SIZE 65536

#ifndef __ASSEMBLY__

#include "mm.h"
#include "cpu.h"
#include "asmmacros.h"
#include "shared_structs.h"

void netos_exec (void (*func_ptr)(void *), void *arg, unsigned int mask);

/*
 * 'current' points to the current task struct. The task
 * struct could be of different types. One using linux
 * source base might prefer to use linux task structure
 * while those using 'pth' library might want 'current'
 * to point to 'pth_current'. Hence 'current' must be
 * set by individual modules. It is defined and 
 * initialized to NULL in srcs/kernel/kernel/time.c
 */

extern void *current;
extern unsigned int netos_mips_hpt_frequency;

extern int init_netos(void);

#define is_xls_608() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x80)
#define is_xls_408() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x88)
#define is_xls_404() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x8c)
#define is_xls_208() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x8e)
#define is_xls_204() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x8f)
#define is_xls_108() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0xce)
#define is_xls_104() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0xcf)

#define is_xls_616() 	(((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x40)
#define is_xls_608_b0() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x4a)
#define is_xls_416() 	(((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x44)
#define is_xls_412() 	(((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x4c)
#define is_xls_408_b0() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x4e)
#define is_xls_404_b0() (((xlr_read_32bit_cp0_processor_id() & 0xff00) >> 8) == 0x4f)


#define is_xls() (is_xls_608() || is_xls_408() || is_xls_404() || is_xls_208() || is_xls_204()\
		|| is_xls_108() || is_xls_104() \
		|| is_xls_616() || is_xls_608_b0() || is_xls_416() || is_xls_412() || \
			is_xls_408_b0() || is_xls_404_b0())

#define is_xls_b0() ( is_xls_616() || is_xls_608_b0() || is_xls_416() || is_xls_412() ||\
		is_xls_408_b0() || is_xls_404_b0())


#define NLM_PHOENIX_BOARD_ARIZONA_I        1
#define NLM_PHOENIX_BOARD_ARIZONA_II       2
#define NLM_PHOENIX_BOARD_ARIZONA_III      3
#define NLM_PHOENIX_BOARD_ARIZONA_IV       4
#define NLM_PHOENIX_BOARD_ARIZONA_V        5
#define NLM_PHOENIX_BOARD_ARIZONA_VI       6
#define NLM_PHOENIX_BOARD_ARIZONA_VII      7
#define NLM_PHOENIX_BOARD_ARIZONA_VIII     8
#define NLM_PHOENIX_BOARD_ARIZONA_XI      11
#define NLM_PHOENIX_BOARD_ARIZONA_XII     12

static __inline__ int xlr_board_atx_i(void)
{
        return ((xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_I)||
                (xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_IV));
}

static __inline__ int xlr_board_atx_ii(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_II;
}


static __inline__ int xlr_board_atx_ii_b(void)
{
        return  (xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_II) &&
                (xlr_fdt.minor == 1);

}

static __inline__ int xlr_board_atx_iii(void)
{
        return (xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_III);
}

static __inline__ int xlr_board_atx_iii_256(void)
{
        return (xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_III)
                && (xlr_fdt.minor == 0);
}

static __inline__ int xlr_board_atx_iii_512(void)
{
        return (xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_III)
                && (xlr_fdt.minor == 1);
}

static __inline__ int xlr_board_atx_iv(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_IV;
}

static __inline__ int xlr_board_atx_v(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_V;
}

static __inline__ int xls_board_atx_vi(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_VI;
}

static __inline__ int xls_board_atx_vii(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_VII;
}

static __inline__ int xls_board_atx_viii(void)
{
        return xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_VIII;
}

static __inline__ int is_xls_board_xi_xii (void ) 
{
	return 	((xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_XI ) 
			|| ( xlr_fdt.major == NLM_PHOENIX_BOARD_ARIZONA_XII ));
}

static __inline__ int is_xls_board_xaui_rework (void )
{
	if (is_xls_board_xi_xii() && (xlr_fdt.minor == 4))
		return 1;
	else
		return 0;
}

/* Returns 1 if the specified block is in XAUI mode */
int xlsb0_in_xaui(int block);

#endif

#define NCPU 32

#endif
