/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#include <stdio.h>
#include <system.h>
#include <iomap.h>
#include "pic.h"
#include "irq.h"
#include <stddef.h>
#include <debug.h>
#include <mips-exts.h>
#include <timer.h>
#include "spinlock.h"
#include "xlr_boot_lib.h"

#include "handlers.h"

irqreturn_t wakeup_cpu_ipi_handler(int irq, struct pt_regs *regs) 
{
	return 0;
}

irqreturn_t stop_cpu_ipi_handler(int irq, struct pt_regs *regs) 
{

	/* Jump To Renentry Function Provided by master */

	int pid = processor_id();
		
	/* Check if application needs to do cleanup */

	if (netos_shutdown_func[pid]) {
		netos_shutdown_func[pid](netos_shutdown_args[pid]);
		netos_shutdown_func[pid] = NULL;
	}

	printf("\nNo retnry function provided... putting this thread in halt state\n");
	cli();
	__asm__ volatile(
		"wait\n"
		);
	
	return 0;
}

irqreturn_t join_cpu_ipi_handler(int irq, struct pt_regs *regs) 
{
	return 0;
}
