/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

[Setup]
AppName=NETOS Developement Environment
AppVerName=NETOS Developement Environment 0.0.1
AppPublisher=NLM
AppPublisherURL=http://www.razamicroelectronics.com/
AppSupportURL=http://www.razamicroelectronics.com/
AppUpdatesURL=http://www.razamicroelectronics.com/
DefaultDirName=c:\nlmdev
DefaultGroupName=NETOS Developement Environment
LicenseFile=docs\License.txt
OutputBaseFilename=setup
OutputDir=Output
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Files]
Source: "sources\*"; DestDir: "{app}\sources"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "netos_lib\*"; DestDir: "{app}\netos_lib"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "nlmtools\*"; DestDir: "{app}\nlmtools"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "docs\*"; DestDir: "{app}\docs"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\{cm:UninstallProgram,NETOS Dev Env}"; Filename: "{uninstallexe}"
Name: "{group}\NLM Insight Launcher"; Filename: "{app}\nlmtools\bin\wish84.exe" ; Parameters: "{app}\nlmtools\bin\nlmlaunch.tcl"
Name: "{group}\Manual"; Filename: "{app}\docs\netos_dev_manual.pdf"

[UninstallDelete]
Type: filesandordirs; Name: "{app}\sources"

[Code]
function NextButtonClick(CurPageID: Integer): Boolean;
begin
  Result := True;
  if (CurPageID = wpSelectDir)
  then
    if ( Pos(' ', ExpandConstant('{app}')) <> 0) then
    begin
      MsgBox('You cannot have spaces in the Installation Directory name!', mbCriticalError, MB_OK);
      Result := False;
    end
end;

procedure CurStepChanged(CurStep: TSetupStep);
var
  CurPath: String;
  AppBin:  String;
  RetCode: Boolean;
begin
  if CurStep = ssPostInstall then
  begin
    AppBin := ExpandConstant('{app}\nlmtools\bin');
    if not RegWriteStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment',
                                 'NETOS_LIB', ExpandConstant('{app}\netos_lib')) then
    begin
      MsgBox('Setting system environment variable NETOS_LIB in registry failed! You will need to set it manually.', mbError, MB_OK);
    end

    if RegQueryStringValue(HKEY_CURRENT_USER, 'Environment', 'PATH', CurPath) then
    begin
       RetCode := RegWriteStringValue(HKEY_CURRENT_USER, 'Environment', 'PATH', CurPath + ';' + AppBin);
    end
    else
    begin
       RetCode := RegWriteStringValue(HKEY_CURRENT_USER, 'Environment', 'PATH', AppBin);
    end
    if not RetCode then
    begin
      MsgBox('Setting Registry HKCU/Environment variable PATH in failed! You will need to set it manually.', mbError, MB_OK);
    end
  end
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
var
  CurPath: String;
  AppBin:  String;
begin
  if CurUninstallStep = usUninstall then
  begin
    AppBin := ExpandConstant('{app}\nlmtools\bin');

    RegDeleteValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'NETOS_LIB');
    if RegQueryStringValue(HKEY_CURRENT_USER, 'Environment', 'PATH', CurPath) then
    begin
      if AppBin = CurPath then
      begin
        RegDeleteValue(HKEY_CURRENT_USER, 'Environment', 'PATH');
      end
      else
      begin
        StringChange(CurPath, ';' + AppBin, '');
        RegWriteStringValue(HKEY_CURRENT_USER, 'Environment', 'PATH', CurPath);
      end
    end
  end
end;
