/* Note > Key is expanded by appending zeros at the end of the key to make it B
 * size (blocksize). If key size is greater than B, H(K) is computed to get B
 * bytes output key*/
/* To be added... Different key sizes */
struct test_params sha384_hmac_test_params = {
//	.flag = 0,
	.cipher_alg = NLM_CIPHER_BYPASS,
	.cipher_mode = 0, 
	.auth_alg = NLM_AUTH_SHA,
	.auth_mode = NLM_AUTH_MODE_SHA384,
	.cipher_iv_len = 0,
	.cipher_key_len = 0,
	.hmac = 1,
//	.max_auth_key_len = NLM_SHA384_KEY_LEN,  ???
	.designer_desc_valid = 0, 
//	.designer_desc[4];
};

struct test_data cipher_null_auth_sha384_hmac_test_data[NR_TESTS_SHA384_HMAC] = {
/*rfc 4868 */
	{
	.len = 8,
	.auth_len = 8,
	.auth_key_len = 48,
	.auth_key = "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b",
	/* Keys longer than block size(B=L) is reduced to length L by applying
	 * following funcion: (L is output of authentication)
	 * H(K) ->Hash function on Key... Resultant L is used as key 
	 */
	.in = "4869205468657265", /* Hi There */
	.digest = "b6a8d5636f5c6a7224f9977dcf7ee6c7fb6d0c48cbdee973",
	.digest_len = 24,
	},
/*rfc 4868 */
	{
	.len = 28,
	.auth_len = 28,
	.auth_key_len = 48,
	.auth_key = "4a6566654a6566654a6566654a6566654a6566654a6566654a6566654a6566654a6566654a6566654a6566654a656665",
	.in = "7768617420646f2079612077616e7420666f72206e6f7468696e673f", /* What do you want for nothing*/
	.digest = "2c7353974f1842fd66d53c452ca42122b28c0b594cfb184d",
	.digest_len = 24,
	},
/*rfc 4868 */
	{
	.len = 50,
	.auth_len = 50,
	.auth_key_len = 48,
	.auth_key = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
	.in = "dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd", /* 50 bytes*/
	.digest = "809f439be00274321d4a538652164b53554a508184a0c316",
	.digest_len = 24,
	},
/*rfc 4868 */
	{
	.len = 50,
	.auth_len = 50,
	.auth_key_len = 48,
	.auth_key = "0102030405060708090a0b0c0d0e0f101112131415161718191a1b1c1d1e1f200a0b0c0d0e0f10111213141516171819",
	.in = "cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd", /* 50 bytes*/
	.digest = "5b540085c6e6358096532b2493609ed1cb298f774f87bb5c",
	.digest_len = 24,
	},
};
